#include "config_parser.h"
#include <iostream>

ConfigParser::ConfigParser(const std::string& filename) : reader(filename) {
    if (reader.ParseError() != 0) {
        std::cerr << "Can't load " << filename << std::endl;
        exit(1);
    }
}

std::string ConfigParser::getSimulationName() const {
    return reader.Get("global", "simulation_name", "default_simulation");
}

int ConfigParser::getNumPopulations() const {
    return reader.GetInteger("global", "num_populations", 1);
}

int ConfigParser::getSimulationRuns() const {
    return reader.GetInteger("global", "simulation_runs", 1);
}

std::string ConfigParser::getDiseaseName() const {
    return reader.Get("disease", "name", "unknown");
}

int ConfigParser::getDiseaseDuration() const {
    return reader.GetInteger("disease", "duration", 1);
}

double ConfigParser::getDiseaseTransmissibility() const {
    return reader.GetReal("disease", "transmissibility", 0.0);
}

const INIReader& ConfigParser::getReader() const {
    return reader;
}
