#ifndef CONFIG_PARSER_H
#define CONFIG_PARSER_H

#include <string>
#include <INIReader.h>

class ConfigParser {
public:
    ConfigParser(const std::string& filename);
    std::string getSimulationName() const;
    int getNumPopulations() const;
    int getSimulationRuns() const;
    std::string getDiseaseName() const;
    int getDiseaseDuration() const;
    double getDiseaseTransmissibility() const;

    const INIReader& getReader() const;

private:
    INIReader reader;
};

#endif // CONFIG_PARSER_H
