#include "person.h"
#include <random>
#include <iostream>

Person::Person(State initial_state) : state(initial_state), days_infectious(0) {}

void Person::updateState(int disease_duration) {
    if (state == Infectious) {
        days_infectious++;
        if (days_infectious >= disease_duration) {
            state = Recovered;
        }
    }
}

void Person::tryInfect(double transmissibility) {
    if (state == Susceptible) {
        std::random_device rd;
        std::mt19937 gen(rd());
        std::uniform_real_distribution<> dis(0.0, 1.0);
        if (dis(gen) < transmissibility) {
            state = Infectious;
            days_infectious = 0;
        }
    }
}

Person::State Person::getState() const {
    return state;
}

void Person::setState(State new_state) {
    state = new_state;
}
