#ifndef POPULATION_H
#define POPULATION_H

#include <vector>
#include <string>
#include "person.h"

class Population {
public:
    Population(const std::string& name, int size, double vaccination_rate, bool patient_zero);
    void simulateDay(double transmissibility, int disease_duration);
    bool hasInfectious() const;
    std::string getName() const;
    void getStatistics(int& susceptible, int& infectious, int& vaccinated, int& recovered) const;
    void randomContact(Population& other_population, double transmissibility);

private:
    std::string name;
    std::vector<Person> people;
};

#endif // POPULATION_H
